# coding: utf-8

"""
    Airflow API

    Airflow API. All endpoints located under ``/api/v2`` can be used safely, are stable and backward compatible. Endpoints located under ``/ui`` are dedicated to the UI and are subject to breaking change depending on the need of the frontend. Users should not rely on those but use the public ones instead.

    The version of the OpenAPI document: 2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class TaskInstanceState(str, Enum):
    """
    All possible states that a Task Instance can be in.  Note that None is also allowed, so always use this in a type hint with Optional.
    """

    """
    allowed enum values
    """
    REMOVED = 'removed'
    SCHEDULED = 'scheduled'
    QUEUED = 'queued'
    RUNNING = 'running'
    SUCCESS = 'success'
    RESTARTING = 'restarting'
    FAILED = 'failed'
    UP_FOR_RETRY = 'up_for_retry'
    UP_FOR_RESCHEDULE = 'up_for_reschedule'
    UPSTREAM_FAILED = 'upstream_failed'
    SKIPPED = 'skipped'
    DEFERRED = 'deferred'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of TaskInstanceState from a JSON string"""
        return cls(json.loads(json_str))


